#!/usr/bin/env sh

set -eu

# @getoptions
parser_definition() {
  setup REST help:help -- 'Usage: settings.sh [options]...'
  msg --
  msg -- 'Options:'
  param PREFIX -p --prefix init:='settings' -- 'Set prefix'
  param MESSAGE -m --message init:='chore: Update settings subtree' -- 'Set commit message'
  param REMOTE -r --remote init:='settings' -- 'Set remote'
  param BRANCH -b --branch init:='master' -- 'Set branch'
  disp :help -h --help -- 'Show help'
  msg --
  msg -- 'Commands:'
  cmd pull -- 'Pull settings'
  cmd push -- 'Push settings'
}
# @end

# @gengetoptions parser -i parser_definition parse
# Generated by getoptions (BEGIN)
# URL: https://github.com/ko1nksm/getoptions (v3.3.0)
PREFIX='settings'
MESSAGE='chore: Update settings subtree'
REMOTE='settings'
BRANCH='master'
REST=''
parse() {
  OPTIND=$(($#+1))
  while OPTARG= && [ $# -gt 0 ]; do
    case $1 in
      --?*=*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%%\=*}" "${OPTARG#*\=}"' ${1+'"$@"'}
        ;;
      --no-*|--without-*) unset OPTARG ;;
      -[pmrb]?*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%"${OPTARG#??}"}" "${OPTARG#??}"' ${1+'"$@"'}
        ;;
      -[h]?*) OPTARG=$1; shift
        eval 'set -- "${OPTARG%"${OPTARG#??}"}" -"${OPTARG#??}"' ${1+'"$@"'}
        OPTARG= ;;
    esac
    case $1 in
      '-p'|'--prefix')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        PREFIX="$OPTARG"
        shift ;;
      '-m'|'--message')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        MESSAGE="$OPTARG"
        shift ;;
      '-r'|'--remote')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        REMOTE="$OPTARG"
        shift ;;
      '-b'|'--branch')
        [ $# -le 1 ] && set "required" "$1" && break
        OPTARG=$2
        BRANCH="$OPTARG"
        shift ;;
      '-h'|'--help')
        help
        exit 0 ;;
      --)
        while [ $# -gt 0 ]; do
          REST="${REST} \"\${$(($OPTIND-$#))}\""
          shift
        done
        break ;;
      [-]?*) set "unknown" "$1"; break ;;
      *)
        case $1 in 'pull'|'push') ;;
          *) set "notcmd" "$1"; break
        esac
        while [ $# -gt 0 ]; do
          REST="${REST} \"\${$(($OPTIND-$#))}\""
          shift
        done
        break ;;
    esac
    shift
  done
  [ $# -eq 0 ] && { OPTIND=1; unset OPTARG; return 0; }
  case $1 in
    unknown) set "Unrecognized option: $2" "$@" ;;
    noarg) set "Does not allow an argument: $2" "$@" ;;
    required) set "Requires an argument: $2" "$@" ;;
    pattern:*) set "Does not match the pattern (${1#*:}): $2" "$@" ;;
    notcmd) set "Not a command: $2" "$@" ;;
    *) set "Validation error ($1): $2" "$@"
  esac
  echo "$1" >&2
  exit 1
}
help() {
cat<<'GETOPTIONSHERE'
Usage: settings.sh [options]...

Options:
  -p, --prefix PREFIX         Set prefix
  -m, --message MESSAGE       Set commit message
  -r, --remote REMOTE         Set remote
  -b, --branch BRANCH         Set branch
  -h, --help                  Show help

Commands:
  pull      Pull settings
  push      Push settings
GETOPTIONSHERE
}
# Generated by getoptions (END)
# @end

case "${1-}" in
    pull)
        git subtree pull -m "$MESSAGE" -P "$PREFIX" "$REMOTE" "$BRANCH"
    ;;
    push)
        git subtree push -m "$MESSAGE" -P "$PREFIX" --rejoin "$REMOTE" "$BRANCH"
    ;;
    "")
        echo "No command found"
        exit 1
    ;;
    *)
        echo "Unrecognized command: ${1-}"
        exit 1
    ;;
esac
